/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.celestial.mockexamplemvn;

//import some necessary classes from the package of JUnit4
import org.junit.Test;
//import some necessary classes from the package of JMock2.2
import org.jmock.Mockery;
import org.jmock.integration.junit4.JUnit4Mockery;
import org.jmock.Expectations;
import static org.jmock.Expectations.onConsecutiveCalls;
import static org.jmock.Expectations.returnValue;
import org.jmock.auto.*;
import static org.junit.Assert.assertEquals;
import org.junit.Before;


public class JMock_GreetingTest
{
    //create the context for the mock object
    Mockery context = new JUnit4Mockery();
    GreetingTime gt;
    
    @Before
    public  void    setup()
    {
        System.out.println("Test hello");
        gt = context.mock(GreetingTime.class);
    }

    @Test
     public void testSayHello_1()
    {
         //Mock the GreetingTime class using the technology of reflection
         Greeting g = new Greeting();
         g.setGreetingTime(gt);

         //set the expection for the mock object
         context.checking(new Expectations()
         {{
              //the mock object will call the getGreeting method once
              //and we assume that is returns “Good afternoon”
              oneOf(gt).getGreeting(); will(returnValue("Good afternoon"));
          }});

         String out = g.sayGreeting("wu cao");
         //compare the result and expected value
         assertEquals("Good afternoon, wu cao",out);
     }

    @Test
     public void testSayHello_2()
    {
         Greeting g = new Greeting();
         g.setGreetingTime(gt);

         //set the expection for the mock object
         context.checking(new Expectations()
         {{
              exactly(2).of(gt).getGreeting(); will(returnValue("Good afternoon"));
          }});

         String out_1 = g.sayGreeting("wu cao"); 
         String out_2 = g.sayGreeting("gotcha");
         
         //compare the result and expected value
         assertEquals("Good afternoon, wu cao", out_1 );
         assertEquals("Good afternoon, gotcha", out_2 );
         
         context.assertIsSatisfied();
     }

    @Test
     public void testSayHello_3()
    {
         Greeting g = new Greeting();
         g.setGreetingTime(gt);

         //set the expection for the mock object
         context.checking(new Expectations()
         {{
              atLeast(1).of(gt).getGreeting();
                will(onConsecutiveCalls(
                    returnValue("Good afternoon"),
                    returnValue("Good morning"),
                    returnValue("Good evening")));
          }});

         String out_1 = g.sayGreeting("wu cao"); 
         String out_2 = g.sayGreeting("wu cao"); 
         String out_3 = g.sayGreeting("wu cao"); 

         //compare the result and expected value
         assertEquals("Good afternoon, wu cao", out_1);
         
         context.assertIsSatisfied();
     }

    @Test
    public void testSayHello_4()
    {
         Greeting g = new Greeting();
         g.setGreetingTime(gt);

         //set the expection for the mock object
         context.checking(new Expectations()
         {{
             
              exactly(1).of(gt).getGreeting();
                will(onConsecutiveCalls(
                    returnValue("Good afternoon"),
                    returnValue("Good morning"),
                    returnValue("Good evening")));
          }});

         String out_1 = g.sayGreeting("wu cao"); 
         String out_2 = g.sayGreeting("wu cao"); 

         //compare the result and expected value
         assertEquals("Good afternoon, wu cao", out_1);
         
         context.assertIsSatisfied();
     }
}
